# RakNet::NatTypeDetectionServer Class Reference
[NatTypeDetection]

Server code for NatTypeDetection. More...

`#include <NatTypeDetectionServer.h>`

Inheritance diagram for RakNet::NatTypeDetectionServer:

List of all members.

## Public Member Functions
void | Startup (const char *nonRakNetIP2, const char *nonRakNetIP3, const char *nonRakNetIP4)
virtual void | Update (void)
| Update is called every time a packet is checked for .
virtual PluginReceiveResult | OnReceive (Packet *packet)
virtual void | OnClosedConnection (SystemAddress systemAddress, RakNetGUID rakNetGUID, PI2_LostConnectionReason lostConnectionReason)

## Detailed Description

Server code for NatTypeDetection.

Sends to a remote system on certain ports and addresses to determine what type of router, if any, that client is behind Requires that the server have 4 external IP addresses

1. Server has 1 instance of RakNet. Server has four external ip addresses S1 to S4. Five ports are used in total P1 to P5. RakNet is bound to S1P1. Sockets are bound to S1P2, S2P3, S3P4, S4P5
2. Client with one port using RakNet (C1). Another port not using anything (C2).
3. C1 connects to S1P1 for normal communication.
4. S4P5 sends to C2. If arrived, no NAT. Done. (If didn't arrive, S4P5 potentially banned, do not use again).
5. S2P3 sends to C1 (Different address, different port, to previously used port on client). If received, Full-cone nat. Done. (If didn't arrive, S2P3 potentially banned, do not use again).
6. S1P2 sends to C1 (Same address, different port, to previously used port on client). If received, address-restricted cone nat. Done.
7. Server via RakNet connection tells C1 to send to to S3P4. If address of C1 as seen by S3P4 is the same as the address of C1 as seen by S1P1 (RakNet connection), then port-restricted cone nat. Done
8. Else symmetric nat. Done.

See also http://www.jenkinssoftware.com/raknet/manual/natpunchthrough.html

See also:
  NatPunchthroughServer

  NatTypeDetectionClient

## Member Function Documentation

virtual void RakNet::NatTypeDetectionServer::OnClosedConnection | ( | SystemAddress | systemAddress,
|  | RakNetGUID | rakNetGUID,
|  | PI2_LostConnectionReason | lostConnectionReason |
| ) |  |  | `[virtual]`

Called when a connection is dropped because the user called RakPeer::CloseConnection() for a particular system

Parameters:

  `[in]` | systemAddress | The system whose connection was closed
  `[in]` | rakNetGuid | The guid of the specified system
  `[in]` | lostConnectionReason | How the connection was closed: manually, connection lost, or notification of disconnection

Reimplemented from PluginInterface2.

virtual PluginReceiveResult RakNet::NatTypeDetectionServer::OnReceive | ( | Packet * | packet | ) | `[virtual]`

OnReceive is called for every packet.

Parameters:

  `[in]` | packet | the packet that is being returned to the user

Returns:
  True to allow the game and other plugins to get this message, false to absorb it

Reimplemented from PluginInterface2.

void RakNet::NatTypeDetectionServer::Startup | ( | const char * | nonRakNetIP2,
|  | const char * | nonRakNetIP3,
|  | const char * | nonRakNetIP4 |
| ) |  |  |

Start the system, binding to 3 external IPs not already in useS

Parameters:

  `[in]` | nonRakNetIP2 | First unused external IP
  `[in]` | nonRakNetIP3 | Second unused external IP
  `[in]` | nonRakNetIP4 | Third unused external IP

The documentation for this class was generated from the following file:

- d:/RakNet-3.x/Source/NatTypeDetectionServer.h